/*--------------------------------------------------------------------------
 *
 * 	You may freely copy, distribute, and reuse the code in this example.
 * 	SHL Systemhouse disclaims any warranty of any kind, expressed or  
 *	implied, as to its fitness for any particular use.
 *
 *
 *	AppController
 *
 *	Inherits From:		NSObject
 *
 *	Conforms To:		None
 *
 *	Declared In:		AppController.h
 *
 *	Class Description
 *
 *		Application controller for EO delegates example.
 *
 *
 *------------------------------------------------------------------------*/
#import <foundation/NSObject.h>



@interface AppController : NSObject
{
	id		console;
	id		consoleButton;
	id		eoController;
	id		eofDelegate;
	
	BOOL	trace;
	BOOL	verbose;
	BOOL	alert;
}

/*--------------------------------------------------------------------------
 *	Tracing
 *------------------------------------------------------------------------*/
- (BOOL) isTracing;
- (BOOL) isVerbose;
- (BOOL) wantsAlertPanels;

- setTracingOFF: sender;
- setIsVerbose: sender;
- setWantsAlertPanels: sender;
- console:sender;


/*--------------------------------------------------------------------------
 *	Announcing Trace Info
 *------------------------------------------------------------------------*/
- (void) announce:sender selector:(SEL)selector;
- (void) announce:sender selector:(SEL)selector with:array;


/*--------------------------------------------------------------------------
 *	Modifying EOController Characteristics
 *------------------------------------------------------------------------*/
- setEnableUndo: sender;
- setAutomaticUndoMarks: sender;
- setBufferEdits: sender;
- setBufferOperations: sender;
- setMaximumUndoEntries: sender;


/*--------------------------------------------------------------------------
 *	Setting Delegates
 *------------------------------------------------------------------------*/
- setDelegates: sender;


@end
