#
#  NeXT Internal Library Makefile
#  Copyright 1987, 1991, NeXT Computer, Inc.
#
#  This Makefile is used for NeXT software libraries.
#
#  Fill in values for the various variables at the places marked by
#  **number**.  Any rules or dependencies of your own can be added
#  at the end of the file.
#

DSTROOT = /.

# directory where included Makefiles are located.
MAKE_DIR = /LocalDeveloper/Makefiles/lib

#  **1**  -LIBRARY NAME-
#  The base name of the library goes here. This should be the same
#  name as the SGS project the library is built under.  For example, if
#  you enter "appkit" as the name, then the name of the SGS project
#  should be "appkit", and the library created will be "libappkit.a".
NAME = gamekit

#  **2**  -SOURCE FILES-
#  Here list the .m, .c, .psw, .pswm, .s, .l, .lm, .y, .ym, .ps and
#  .spec files.  You may delete any lines that you don't use.
#  OTHER_SRCS is used for files with other suffixes that you wish
#  to be treated like source (i.e., printed with the source, copied
#  with the source, etc.).  For files in OTHER_SRCS, you need to
#  specify the corresponding .o file in OTHER_SRCS_OFILES.
MFILES = BonusTracker.m \
	ArrayBonusTracker.m \
	RandomBonusTracker.m \
	ScoreKeeper.m \
	Animator.m \
	AnimatedView.m \
	DirtPile.m \
	GameBrain.m \
	GameView.m \
	GameActor.m \
	GameInfo.m \
	WinDel.m \
	HighScoreDistributor.m \
	HighScoreController.m \
	HighScoreTable.m \
	HighScoreServer.m \
	HighScoreSlot.m \
	GKHSLocalServer.m \
	GKHighScorePanel.m \
	InfoController.m \
	PreferencesBrain.m \
	GKSound.m \
	GKSoundStream.m \
	SoundPlayer.m \
	PlayerUpView.m \
	GrayView2.m \
	GKActorManager.m \
	GKCollider.m \
	GKCollisionGroup.m \
	GKStage.m \
	GKActor.m \
	GKTextActor.m \
	ScorePlayer.m
# delete the # and add a "\" to the end of the GravyView2.m line above
# to use the MusicKit (ScorePlayer object)

CFILES = 
PSWFILES = GKText.psw
PSWMFILES = 
SFILES = 
LFILES = 
LMFILES = 
YFILES = 
YMFILES = 
PSFILES = 
OTHER_SRCS = 
OTHER_SRCS_OFILES = 

#  **3**  -COMMAND OPTIONS-
#  These are passed as arguments to the Objective-C compiler, pswrap, 
#  as, lex, yacc and speculate.  You may delete lines that you don't use.  
#  All CFLAGS also get passed to Objective-C.
#    DEBUGCFLAGS is substituted for CFLAGS when "debug" is made.
#    PROFCFLAGS is substituted for CFLAGS when "profile" is made.
#  Under OBJCFLAGS, for each library that you use that supplies class
#  and message group files, you must use a -I$(OBJDIR)/XXX, where
#  XXX is the base name of the library.

# Choose one of the following; if you don't have the CCRMA Music Kit, then
# don't use the music kit option...or if you want a library that will link
# without the music kit, turn it off.  There a #ifdefs through the code to
# remove any music kit dependencies, what few there are.
# This line uses the Music Kit:
COMMONCFLAGS = -DGK_USE_MUSICKIT -I../Headers -I/LocalDeveloper/Headers
# This line does not use the Music Kit: (use the first for a fat lib)
#COMMONCFLAGS = -I../Headers -I/LocalDeveloper/Headers -arch i386 -arch m68k
#COMMONCFLAGS = -I../Headers -I/LocalDeveloper/Headers

OBJCFLAGS = 
CFLAGS = -Wall -O2 $(COMMONCFLAGS)
OPTCFLAGS = -O2 $(COMMONCFLAGS)
DEBUGCFLAGS = -g -DDEBUG -Wall $(COMMONCFLAGS)
PROFCFLAGS = -pg -g $(COMMONCFLAGS)
SHLIBCFLAGS = -O2 -DSHLIB $(COMMONCFLAGS)
PSWFLAGS = 
ASFLAGS = 
LFLAGS = 
YFLAGS = 
RANLIBFLAGS = 
# IFLAGS = -q -c  -m 444 -o root -g wheel
IFLAGS = -q -c  -m 444
# MKDIRSFLAGS = -m 755 -o root -g wheel
MKDIRSFLAGS = -m 755
ARFLAGS = ruv
VERSFLAGS = -l

#  **4**  -INCLUDE FILES-
#  Private include files are used by the library's code, but not needed
#  by the library's users.  Public include files are needed by others who
#  will use the library, and must be installed along with the library.
#  Compatibility include files are used to provide for compatibility with
#  previous releases.  Local include files are only used by other local projects.
PUBLIC_INCFILES = ../Headers/gamekit
COMPAT_INCFILES =
LOCAL_INCFILES =
PRIVATE_INCFILES = 

#  **5**  -BY_PRODUCTS GENERATED FROM BUILDS-
#  If your build procedure creates any files other than .o files and the
#  .c and .m files left over from pswrap, you should list them here so
#  they are removed when a make clean is done.
BY_PRODUCTS = 

#  **6**  -INSTALLATION LOCATIONS-
#  The following directories determines where files get installed.
# places where libraries get installed
LIBDIR = $(DSTROOT)/usr/local/lib
SHLIBDIR = $(DSTROOT)/usr/local/shlib

# places where headers get installed
INCDIR = $(DSTROOT)/LocalDeveloper/Headers/$(NAME)
COMPATINC = $(DSTROOT)/LocalDeveloper/2.0CompatibleHeaders/$(NAME)
LCLINC = $(DSTROOT)/LocalDeveloper/Headers/$(NAME)

# place where PostScript package files get installed
# PSLIBDIR = $(DSTROOT)/usr/lib/NextStep

#this file included for standard functionality
include $(MAKE_DIR)/Makefile.lib

#  **7**  -ALL AND INSTALL TARGETS-
#  You must define your own all and install targets here.  "all" should
#  build all products of your project.  "install" should install these
#  products in the filesystem whose root is $(DSTROOT).  There are certain
#  targets defined in Makefile.lib which you can use to fulfill the all
#  and install targets.  These are optimized, debug, profile, shlib,
#  optimized_install, debug_install, profile_install, shlib_install,
#  and common_install.
all:: $(PRODUCT)

install:: common_install profile_install


# You may comment in this line to get dependencies for the include files
# you use.  To generate the dependencies, do a "make depend".
#include Makefile.depends

#  any extra rules or dependencies can be added after this line

precomp:
	echo $(CC) $(CFLAGS) -precomp gamekit.h -o gamekit.p
	(cd ../Headers/gamekit; $(CC) $(CFLAGS) -precomp gamekit.h -o gamekit.p)