
/*
 * AIView.h
 *
 * AIView is a subclass of View responsible for managing the NXEPSImageRep
 * of the ai file and also updating the information fields on the display.
 *
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * Both Terrence Talbot and Digital Tool Works disclaim any warranty
 * of any kind, expressed or implied, as to its fitness for any particular use.
 *
 * Written by:  Terrence Talbot 
 *    Created:  Oct/92
 *
 */

#import <appkit/appkit.h>

@interface AIView:View
{
   NXEPSImageRep  *image;                   /* NXEPSImageRep of current ai file */
   TextField      *heightField;
   TextField      *widthField;
   TextField      *scaleField;
   NXRect          aiRect;                  /* vars kept at a more general level */
   float           aspectRatio;             /* to avoid code duplication and     */
   int             imageScale;              /* lockFocus hassles                 */
}

/* INIT/FREE METHODS */

- free;

/* PRIVATE METHODS */

- setImageToFilename:(const char *)filename;
- display;
- drawSelf:(NXRect *)rects :(int)rectCount;

@end
