//
//	MiscScreenColor.h -- a class for color "tints"  (to specify a halftone)
//		Written by Don Yacktman Copyright (c) 1994 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <misckit/MiscColor.h>

@interface MiscScreenColor:MiscColor <NXTransport>
{
	NXPoint theLocation;
	id theView;
}

+ (BOOL)canInitFromPasteboard:(Pasteboard *)pasteboard;
- setFromPasteBoard:(Pasteboard *)pasteboard;
- writeToPasteBoard:(Pasteboard *)pasteboard;

- initColor:(NXColor)color;
- initColorFromPixel:(NXPoint *)location;
- initColorFromPixel:(NXPoint *)location inView:view;

- (NXColor)actualColor;
- (NXPoint)location;
- view;
- setView:aView;
- setLocation:(NXPoint *)location;
- updateColor;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

- (const char *)getInspectorClassName;
- (NXImage *)getIBImage;

@end