/******************************************************************
 * CLASS:		MiscArrowButton
 * PROGRAMMER:	Todd Thomas 
 * DATE:		Jan 16, 1993
 * VERSION:		1.0
 *
 *	A recreation of that button from Websters.app (in Preferences).
 * This class is just a control to display the ArrowButtonCell. It
 * has the same relationship with ArrowButtonCell, as Button and 
 * ButtonCell. I only added my own designated initializer, and 
 * overrode all the init methods to call it. I also had 
 * to add the class methods to set the cell class to ArrowButtonCell.
 *
 * CHANGES
 *	Added setArrowAlignment/arrowAlignment methods instead of using
 *		the already defined setAlignment/alignment methods. 
 *
 * This object is included in the MiscKit by permission from the author
 * and its use is governed by the MiscKit license, found in the file
 * "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
 * for a list of all applicable permissions and restrictions.
 *******************************************************************/
 
#import <appkit/appkit.h>
 

@interface MiscArrowButton : Button
{
}

+ initialize;
+ setCellClass: classId;

- init;
- initFrame: (const NXRect *)frameRect;
- initFrame:(const NXRect *)frameRect title:(const char *)aString
		tag:(int)anInt target:anObject action:(SEL)aSelector
		key:(unsigned short)charCode enabled:(BOOL)flag;
- initFrame:(const NXRect *)frameRect title:(const char *)aString
		altTitle: (const char *)altString tag:(int)anInt 
		target:anObject action:(SEL)aSelector
		key:(unsigned short)charCode enabled:(BOOL)flag;	

- setArrowAlignment: (int)alignment;
- (int)arrowAlignment;	

@end


@interface MiscArrowButton (IB)

- (const char *)getInspectorClassName;
- (const char *)getEditorClassName;

@end

