/******************************************************************************
 *      $Log$
 ******************************************************************************/

#import <appkit/Matrix.h>

@class SimpleDate;

@interface MiscCalendarMatrix : Matrix 
{
    SimpleDate	*simpleDate;
    id 		dateDelegate;
    NXColor	cellTextColor,
		cellHighlightTextColor,
		cellHighlightColor,
		cellBackgroundColor;
    BOOL	overwriteCellColors;
}

- initFrame:(const NXRect *)frameRect;
- initFrame:(const NXRect *)frameRect mode:(int)aMode cellClass:cellId
  numRows:(int)numRows numCols:(int)numCols;
- initFrame:(const NXRect *)frameRect mode:(int)aMode prototype:aCell
  numRows:(int)numRows numCols:(int)numCols;

- free;

- setDateDelegate:aDateObject;
- dateDelegate;

- overwriteCellColors:(BOOL)yn;
- (BOOL)cellColorsOverwritten;

- setCellBackgroundColor:(NXColor)aColor;
- (NXColor)cellBackgroundColor;
- setBackgroundColor:(NXColor)aColor forCellAt:(int)xPos :(int)yPos;
- (NXColor)backgroundColorForCellAt:(int)xPos :(int)yPos;

- setCellHighlightColor:(NXColor)aColor;
- (NXColor)cellHighlightColor;
- setHighlightColor:(NXColor)aColor forCellAt:(int)xPos :(int)yPos;
- (NXColor)highlightColorForCellAt:(int)xPos :(int)yPos;

- setCellTextColor:(NXColor)aColor;
- (NXColor)cellTextColor;
- setTextColor:(NXColor)aColor forCellAt:(int)xPos :(int)yPos;
- (NXColor)textColorForCellAt:(int)xPos :(int)yPos;

- setCellHighlightTextColor:(NXColor)aColor;
- (NXColor)cellHighlightTextColor;
- setHighlightTextColor:(NXColor)aColor forCellAt:(int)xPos :(int)yPos;
- (NXColor)highlightTextColorForCellAt:(int)xPos :(int)yPos;

- displayDate:sender;

- read:(NXTypedStream *)aStream;
- write:(NXTypedStream *)aStream;

@end
