#import <appkit/View.h>

#import "misckit/DateDelegateProtocol.h"
#import "misckit/MiscCalendarViewConstants.h"

@class MiscCalendarMatrix;
@class DateSelectionCell;
@class TextField;
@class List;
@class Matrix;
@class Box;

@interface MiscCalendarView : View
{
    id			monthField;
    id			yearField;
    id			dateField;
    id			dateDelegate;
    id			textDelegate;

    NXRect		defaultFrame;
    MiscCalendarMatrix	*calendarMatrix;
    DateSelectionCell	*previousDayCell;
    TextField		*monthSubview,
			*yearSubview,
    			*inlineMonthSubview,
			*inlineYearSubview;
    List		*dowSubviewList;
    int			titleDisplayMode;
    BOOL		displayDOWHeader,
			displayMonthAndYearHeader,
			displayMonthHeader,
			displayYearHeader,
			colorDragAndDrop;
}

- finishUnarchiving;
- awakeFromNib;

- initFrame:(const NXRect *)frameRect;

- getMinSize:(NXSize *)minSize maxSize:(NXSize *)maxSize from:(int)where;

- calendarMatrix;

- preserveCellColors:(BOOL)yn;
- (BOOL)cellColorsPreserved;

- setColorOf:(int)element to:(NXColor)aColor forCellAt:(int)xPos :(int)yPos;
- (NXColor)colorOf:(int)element forCellAt:(int)xPos :(int)yPos;

- setColorOf:(int)element to:(NXColor)aColor;
- (NXColor)colorOf:(int)element;

- cellAt:(int)xPos :(int)yPos lock:(BOOL)yn;
- forRow:(int)row lock:(BOOL)yn;
- forColumn:(int)col lock:(BOOL)yn;

- setHighlightMode:(int)mode;
- (int)highlightMode;

- allowColorDragAndDrop:(BOOL)yn;
- (BOOL)canDragAndDropColor;

- forHeader:(int)aHeader display:(BOOL)doDisplay;
- (BOOL)isHeaderDisplayed:(int)aHeader;

- setColorTo:(NXColor)aColor forDay:(MiscCVDays)aDay;
- (NXColor)colorForDay:(MiscCVDays)aDay;

- incrementMonth:sender;
- decrementMonth:sender;

- incrementYear:sender;
- decrementYear:sender;

- updateDate:sender;
- displayDate:sender;

- setDateDelegate:(id <DateDelegate>)anObject;
- (id <DateDelegate>)dateDelegate;

- (const char *)getInspectorClassName;
- (const char *)getEditorClassName;

- read:(NXTypedStream *)aStream;
- write:(NXTypedStream *)aStream;

@end
