//
//	MiscReadOnlyColorWell.m -- an NXColorWell that can bemade read-only
//		Written by Morgan D. Wise (c) 1994 by Morgan D. Wise.
//		Adapted for MiscKit inclusion by Don Yacktman.
//				Version 0.1.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscReadOnlyColorWell.h"

@implementation MiscReadOnlyColorWell

- setReadOnly:(BOOL)flag
{
	_isReadOnly = flag;
	[self setBordered:!flag];		
	return self;
}

- (BOOL)isReadOnly
{
	return _isReadOnly;
}

- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender
{
	if (_isReadOnly) return NX_DragOperationNone;
	else return [super draggingEntered:sender];
}

- (const char *)getInspectorClassName
{
    return "ReadOnlyColorWellInspector";
}

- read:(NXTypedStream *)stream
{
	[super read:stream];
	NXReadType(stream, "c", &_isReadOnly);
	return self;
}

- write:(NXTypedStream *)stream
{
	[super write:stream];
	NXWriteType(stream, "c", &_isReadOnly);
	return self;
}

@end
