//
//	MiscLogSlider.m -- a Slider subclass with logarithmic transfer function
//		Written by Don Yacktman, Copyright (c) 1994 by Don Yacktman.
//				Version 1.0  All rights reserved.
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscLogSlider.h"

static id MiscLogSliderCellClass;

@implementation MiscLogSlider

+ initialize
{
	if (self == [MiscLogSlider class]) {
		MiscLogSliderCellClass = [MiscLogSliderCell class];
		// the default class
	}
    return self;
}

+ setCellClass:classId
{
    MiscLogSliderCellClass = classId;
    return self;
}

- initFrame:(NXRect *)nf
{
    [super initFrame:nf];
    [[self setCell:[[MiscLogSliderCellClass alloc] init]] free];
    return self;
}

- setBase:(double)newBase
{
	[cell setBase:newBase];
	return self;
}

- (double)base
{
	return [cell base];
}

@end
