//
//	MiscTriStateButton.m -- palette class for the three state button
//		Written by Don Yacktman (c) 1993 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//		This is a free object!  Contact the author for the latest version.
//		Don Yacktman, 4279 N. Ivy Lane, Provo, UT, 84604
//		e-mail:  Don_Yacktman@byu.edu
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "MiscTriStateButton.h"
#import "MiscThreeStateButton.subproj/MiscThreeStateButton.h"
#import "MiscThreeStateButton.subproj/MiscThreeStateButtonCell.h"

@implementation MiscTriStateButton

- finishInstantiate
{	// programmatically set up the example/prototype buttons
	// to look the way we want them to look.
	[button1 setTitle:"Neutral"];
	[button1 setAltTitle:"Positive"];
	[button1 setThirdTitle:"Negative"];
	[button1 setType:MISC_CYCLIC_THREE_STATE];
	[button1 setType:NX_TOGGLE];
	[button1 setIcon:"NXswitch"];
	[button1 setAltIcon:"Plus"];
	[button1 setThirdIcon:"DontCare"];
	[button1 setIconPosition:NX_ICONRIGHT];
	[button1 setBordered:NO];
	[button2 setTitle:"Off"];
	[button2 setAltTitle:"On"];
	[button2 setThirdTitle:"In Between"];
	[button2 setType:MISC_PLAIN_THREE_STATE];
	[button2 setType:NX_TOGGLE];
	[button2 setIcon:"NXswitch"];
	[button2 setAltIcon:"NXswitchH"];
	[button2 setThirdIcon:"DontCare"];
	[button2 setIconPosition:NX_ICONRIGHT];
	[button2 setBordered:NO];
	return self;
}

@end
