/*
 *  Copyright (c) 1993 Christopher J. Kane.  All rights reserved.
 *
 *  This software is subject to the terms of the MiscKit license
 *  agreement.  Refer to the license document included with the
 *  MiscKit distribution for these terms.
 *
 *  Version: 1.1 (22 October 1993)
 */

#import <appkit/appkit.h>

@interface MiscFindPanel:Panel
{
  TextField *findTextField;
  TextField *replaceTextField;
  TextField *messageTextField;
  Button    *ignoreCaseButton;
  Button    *regExprButton;
  Matrix    *scopeMatrix;
  Box       *_replBox;
}

+ setFindPbEnabled:(BOOL)aBool;
+ setFirstConformer:aConformer;
+ setReplacementEnabled:(BOOL)aBool;
+ sharedInstance;

- enterSelection:sender;
- findBackward:sender;
- findForward:sender;
- jumpToSelection:sender;
- replace:sender;
- replaceAll:sender;
- replaceAndFind:sender;

- (TextField *)findTextField;
- (Button *)ignoreCaseButton;
- (TextField *)messageTextField;
- (Button *)regExprButton;
- (TextField *)replaceTextField;
- (Matrix *)scopeMatrix;

@end
