/***** Historian.h -- recorded data browser object interface
	NeXTstep Measurement Kit
	by Alex Meyer <ameyer@phoenix.Princeton.EDU>
	for computer science senior thesis
	17 April 1992 -- created
	22 April 1992 -- incorporated structs.h & added more types
*****/

#import <objc/Storage.h>
#import <appkit/Window.h>
#import <appkit/Matrix.h>
#import <appkit/MenuCell.h>
#import <appkit/NXBrowser.h>
#import "TranscriptManager.h"
#import "ButtonPresenter.h"
#import "SliderPresenter.h"
#import "ScrollerPresenter.h"
#import "MenuPresenter.h"
#import <objc/Object.h>

@interface Historian : Object
{
	id window;
	id browser;
	id openMenuCell;
	id closeMenuCell;
	id manager;
	id visPresent;
	BOOL opened;
	int type;
	unsigned index; 
	id indices[TM_NUM];	/* array of Storage objects */
	id presenters[TM_NUM];
}

- (int)app:sender
	openFile:(const char *)filename
	type:(const char *)aType;
- (BOOL)appAcceptsAnotherFile:sender;
- appWillInit:sender;
- appWillTerminate:sender;
- (int)browser:sender
	fillMatrix:matrix
	inColumn:(int)column;
- cellSelected:sender;
- openDoc:sender;
- closeDoc:sender;
- copyDataTo:(void *)dst;
- (NXAtom)getKey;

@end
