/***** RApplication.m -- recording Application object implementation
	NeXTstep Measurement Kit
	by Alex Meyer <ameyer@phoenix.Princeton.EDU>
	for computer science senior thesis
	16 April 1992 -- created
	20 April 1992 -- used poseAs: for ScrollView and removed SliderCell
	21 April 1992 -- added poseAs for RMenu
	23 April 1992 -- used reference to LINKERNAME & removed RButton
	24 April 1992 -- changed over to 100% poseAs: strategy
*****/

#import "ButtonCellCover.h"
#import "SliderCellCover.h"
#import "ScrollerCover.h"
#import "MenuCellCover.h"
#import "RApplication.h"

@implementation RApplication

- startLinker
{
	linker = [TranscriptLinker alloc];
	NXNameObject(LINKERNAME,linker,NXApp);
	[linker init];
	return (self);
}


+ new
{
	[ButtonCellCover poseAs:[ButtonCell class]];
	[SliderCellCover poseAs:[SliderCell class]];
	[ScrollerCover poseAs:[Scroller class]];
	[MenuCellCover poseAs:[MenuCell class]];
	self = [super new];
	[self startLinker];
	return (self);
}


- free
{
	[linker free];
	[super free];
	return (nil);
}

@end
