/*
 *    Filename:	CircularSliderCell.h 
 *    Created :	Sun Oct 18 16:56:22 1992 
 *    Author  :	Vince DeMarco
 *		<vince@whatnxt.cuc.ab.ca>
 *    LastEditDate was "Sun Oct 25 13:47:43 1992"
 */


#import <appkit/ActionCell.h>

@interface CircularSliderCell:ActionCell
{
    float   value;             /* Current Value of Cell */
    float   maxValue;          /* Maximum Value of Cell */
    float   minValue;          /* Mimimum Value of Cell */
    BOOL    pieChart;          /* Display CircularSlider as a pieChart */
    BOOL    jumpToMousePoint;  /* Have the CircularSlider jump to the first mouse
				* down event (YES) or have the CircularSlider object
				* move in relation to the mouse
				*/
    BOOL    hidden;            /* Is the Cell Hidden? */
    float   currentang;        /* Current angle being displayed (ranges from 0 to 360)
				* This is usefull in subclasses of CircularSliderCell
				*/

    float   radius;            /* The radius of the Cell */
    NXPoint center;            /* The center point of the Cell, x,y coordinates */

@private                       /* Private variables */
    float   deltaAngle;
    float   scale_value;
    float   scalex;
    float   scaley;
    BOOL    imFlipped;
}

+ (BOOL)prefersTrackingUntilMouseUp;
- init;
- drawSelf:(const NXRect *)cellFrame inView:controlView;
- drawInside:(const NXRect *)cellFrame inView:aView; 

- (BOOL)startTrackingAt:(const NXPoint *)startPoint inView:aView;
- (BOOL)trackMouse:(NXEvent *)theEvent inRect:(const NXRect *)cellFrame ofView:aView;

- highlight:(const NXRect *)cellFrame inView:aView lit:(BOOL)flag;

- (float)floatValue;
- (double)doubleValue;
- (int)intValue;

- setDoubleValue:(double)value;
- setFloatValue:(float)value;
- setIntValue:(int)value;

- (float)minValue;
- setMinValue:(float)aFloat;
- (float)maxValue;
- setMaxValue:(float)aFloat;

- setDrawAsPieChart:(BOOL)aBOOL;
- (BOOL)drawAsPieChart;

- setJumpToMousePoint:(BOOL)aBOOL;
- (BOOL)jumpToMousePoint;

- setHidden:(BOOL)aBOOL;
- (BOOL)hidden;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end
