//----------------------------------------------------------------------------------------------------
//
//	AnalogClock
//
//	Inherits From:		Clock
//
//	Declared In:		AnalogClock.h
//
//	Class Description
//
//		AnalogClock adds behavior required for specific graphical
//		representation.  An AnalogClock is a fixed size view (64 x 64).
//		Clock hand widths and lengths are fixed based on an expected
//		clock face image size (not less than 48 x 48). Date information is
//		not displayed, however, it is accessible.
//
//
//	Disclaimer
//
//		You may freely copy, distribute and reuse this software and its
//		associated documentation. I disclaim any warranty of any kind, 
//		expressed or implied, as to its fitness for any particular use.
//
//----------------------------------------------------------------------------------------------------
#import "Clock.h"


@interface AnalogClock : Clock
{
	NXColor		hourAndMinuteHandColor;
	NXColor		secondHandColor;
}

//----------------------------------------------------------------------------------------------------
//	Accessing Clock Hand Colors
//----------------------------------------------------------------------------------------------------
- hourAndMinuteHandColor: (NXColor) aColor;
- secondHandColor: (NXColor) aColor;

- (NXColor) hourAndMinuteHandColor;
- (NXColor) secondHandColor;


//----------------------------------------------------------------------------------------------------
//	Action Methods
//----------------------------------------------------------------------------------------------------
- takeHourAndMinuteHandColorFrom: sender;
- takeSecondHandColorFrom: sender;


@end