//----------------------------------------------------------------------------------------------------
//
//	ClockInspector
//
//	Inherits From:		IBInspector
//
//	Declared In:		ClockInspector.h
//
//	Class Description
//
//		ClockInspector is an abstract class for other clock inspectors 
//		that provide IB Attributes inspection for an instance of their class.  
//		This class implements the common requirements. Specific inspectors 
//		will manage details relative to a particular Clock class.
//
//
//	Disclaimer
//
//		You may freely copy, distribute and reuse this software and its
//		associated documentation. I disclaim any warranty of any kind, 
//		expressed or implied, as to its fitness for any particular use.
//
//----------------------------------------------------------------------------------------------------
#import <appkit/appkit.h>
#import <apps/InterfaceBuilder.h>
#import "ImageWell.h"


@interface ClockInspector:IBInspector
{
	id		inspectButton;
	id		inspectorView;

	id		optionsWindow;
	id		timeAndDateWindow;
	id		displayWindow;

	id		options;
	
	id		clockOrAlarmButton;
	id		clock;
	id		alarmOptions;
	id		alarmMode;
	id		alarmSound;
	BOOL	alarmFlag;

	id		backgroundImage;
	id		backgroundColor;
	id		colorOrImage;
	
}

//----------------------------------------------------------------------------------------------------
//	Reverting Attributes
//----------------------------------------------------------------------------------------------------
- revertOptions;
- revertTimeAndDate;
- revertDisplay;
- revertClockTimeAndDate;
- revertAlarmTimeAndDate;


//----------------------------------------------------------------------------------------------------
//	Setting Attributes
//----------------------------------------------------------------------------------------------------
- setClockOptions: sender;

- clockOrAlarm: sender;
- decrementHour: sender;
- decrementMinute: sender;
- decrementSecond: sender;
- decrementMonth: sender;
- decrementDay: sender;
- decrementYear: sender;
- incrementHour: sender;
- incrementMinute: sender;
- incrementSecond: sender;
- incrementMonth: sender;
- incrementDay: sender;
- incrementYear: sender;

- alarmOptions: sender;
- alarmMode: sender;
- alarmSound: sender;
- playAlarmSound: sender;

- imageOrColor: sender;
- setClockBackgroundColor: sender;
- setClockBackgroundImage: sender;


@end