//---------------------------------------------------------------------------------------------------------
//
//	ColorBrowser
//
//	Inherits From:		NXBrowser
//
//	Declared In:		ColorBrowser.h
//
//	Class Description
//
//		ColorBrowser is an NXBrowser subclass that uses a
//		ColorBrowserCell as its Cell class.  The ColorBrowserCell
//		allows access to the color attribute of a cell's Text object. 
//		Methods have been added to the ColorBrowser class to
//		support this (A ColorBrowserCell may be used as the Cell
//		class for an NXBrowser instance as well, however, not with 
//		benefit of the 'color friendly' methods added here).  
//
//
//	Disclaimer
//
//		You may freely copy, distribute and reuse this software and its
//		associated documentation. I disclaim any warranty of any kind, 
//		expressed or implied, as to its fitness for any particular use.
//
//---------------------------------------------------------------------------------------------------------
#import <appkit/appkit.h>

@interface ColorBrowser : NXBrowser

{
}

//---------------------------------------------------------------------------------------------------------
//	 Setting Cell Color
//---------------------------------------------------------------------------------------------------------
- setTextColor:(NXColor)aColor forCellWithStringValue:(const char*)aString inColumn:(int) aColumn;
- setTextColor:(NXColor)aColor forCellWithIntValue: (int) anInt  inColumn: (int) aColumn;
- setTextColor:(NXColor)aColor forCellWithFloatValue: (float) aFloat  inColumn: (int) aColumn;
- setTextColor:(NXColor)aColor forCellWithDoubleValue: (double)aDouble inColumn: (int) aColumn;
- setTextColor:(NXColor)aColor forCellWithTag: (int) aTag  inColumn: (int) aColumn;
- setTextColor:(NXColor)aColor forCellInRow: (int) aRow  inColumn: (int) aColumn;
- setTextColor:(NXColor)aColor inColumn: (int) aColumn;
- setTextColorOfSelectedCells:(NXColor)aColor;

@end