//---------------------------------------------------------------------------------------------------------
//
//	ColorBrowserCell
//
//	Inherits From:		NXBrowserCell
//
//	Declared In:		ColorBrowserCell.h
//
//	Class Description
//
//		ColorBrowserCell is a subclass of NXBrowserCell that provides
//		access to the color attribute of the Text object used in drawing the 
//		cell's text. Specificly, ColorBrowserCell allows the Text object's
//		color to be any valid NXColor, whereas, NXBrowserCell only
//		provides access to gray-scale color.
//
//
//	Disclaimer
//
//		You may freely copy, distribute and reuse this software and its
//		associated documentation. I disclaim any warranty of any kind, 
//		expressed or implied, as to its fitness for any particular use.
//
//---------------------------------------------------------------------------------------------------------
#import <appkit/appkit.h>


@interface ColorBrowserCell : NXBrowserCell
{
	NXColor		textColor;
}

//---------------------------------------------------------------------------------------------------------
//	Accessor Methods
//---------------------------------------------------------------------------------------------------------
- (NXColor) textColor;
- setTextColor: (NXColor) aColor;


@end