
#import <appkit/appkit.h>
#import "ExtList.h"
#import <apps/InterfaceBuilder.h>
#import "EDBConnections.h"

@interface EDBConnectInspector:IBInspector
{
	id	actionMatrix;
    id	actionScrollView;
    id	actionTitleField;
    id	commentField;
    id	connectMatrix;
    id	connectScrollView;
    id	lowerBox;
    id	outletBrowser;
    id	upperBox;

	ExtList			*connections;
	NXCoord			minHeight;
	List			*outlets;
	u_long			outletCount;
	BOOL			refreshOnRevert;
}

+ obtainEDBConnectInspector;

- init;
- free;
- ok:sender;
- revert:sender;
- (BOOL)wantsButtons;

- clickAction:sender;
- clickConnection:sender;
- clickOutlet:sender;
- doubleClickOutlet:sender;

- getConnections:list;
- displayConnections:list;
- selectOutlet;
- outletAt:cell inMatrix:matrix setConnected:(BOOL)flag andDisplay:(BOOL)disp;
- (int)indexOfOutlet:(NXAtom)name;
- (int)indexOfFirstFreeOutlet;
- (BOOL)outletIsConnected:(int)ind;
- fillTargetMatrixForConnection:connection andOutlet:(int)outletNr;
- setSequenceNumberFor:connector;
- removeSequenceNumberOf:connector;
- createConnectorForOutlet:(NXAtom)outletName withNr:(int)outletNr
	andSel:(const char *)sel;

- outletOfObject:sender renamedFrom:(NXAtom)from to:(NXAtom)to;
- outlet:(NXAtom)name removedFromObject:sender;
- outletAddedToObject:sender;

- (int)browser:sender fillMatrix:matrix inColumn:(int)column;

@end
