// HotShape.h
// By Charles G. Fleming, Educational Computing Services, Allegheny College.
// Copyright 1992 Allegheny College
// You may freely copy, distribute and reuse this code. 
// Allegheny College and the author disclaim any warranty of any kind, 
// expressed or implied, as to its fitness for any particular use.
// This work was partially supported by a grant from the Vira Heinz Endowment.

#import <appkit/appkit.h>

@interface HotShape:Control
{
	char *hotPathName;
	BOOL visible;
}

- (const char *)getInspectorClassName;
- initFrame:(const NXRect *)frameRect;
- (BOOL)acceptsFirstMouse;
- mouseDown:(NXEvent *)theEvent;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- awake;
- sizeTo:(NXCoord)width :(NXCoord)height;
- setHotPathName:(const char *)name;
- (char *)hotPathName;
- (BOOL)visible;
- setVisible:(BOOL)seeIt;
- read:(NXTypedStream *)typedStream;
- write:(NXTypedStream *)typedStream;

- (BOOL)traverseTreeWithRoot:root startAt:(int)at 		
		usingLocation:(NXPoint)windowCoords;
- (BOOL)inHotPath:(NXPoint)location;

@end
