//
//	DAYStopwatch.h -- a generic class to time things (measure)
//		Written by Don Yacktman (c) 1993 by Don Yacktman.
//				Version 1.0.  All rights reserved.
//
//		This is a free object!  Contact the author for the latest version.
//		Don Yacktman, 4279 N. Ivy Lane, Provo, UT, 84604
//		e-mail:  Don_Yacktman@byu.edu
//
//	See DAYStopWatch.m for details of the software license.
//

#import <daymisckit/DAYTime.h>
#import <sys/time.h>

@interface DAYStopwatch:DAYTime
{
	BOOL paused;
	struct timeval startTime;
}

- init;

- setRelative:(BOOL)t;

- clearTiming:sender;
- startTiming:sender;
- continueTiming:sender;
- pauseTiming:sender;
- calcElapsedTime:sender;

- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end
